; ======================================================================
; GAME OF LIFE - CHIP SPECIAL PROGRAMME MZ-700/MZ-800 - 1986
;                REIHE 2 82004/86004
; (c) JOACHIM PODLECH
; ----------------------------------------------------------------------
; Regles :
;  Si la cellule existe ALORS
;   Si elle est entouree de moins de 2 voisines elle meure
;   Sinon Si elle possède plus de 3 voisines elle meure
;   Sinon elle vit
;  Sinon si elle n'existe pas Alors
;   Si elle a 3 voisines elle nait
; ======================================================================

ORG 0xB000

ADRESSE_CODE:	EQU 0xB000
ADRESSE_EXEC:	EQU 0xB000

LANGAGE:        EQU 0x00 ; 0=Francais ; 1=Deutch  ; 2=English

; ======================================================================
; Fonctions moniteur 1Z-013A
; ----------------------------------------------------------------------
GETL:           EQU 0x0003  ; GET LINE (END "CR")
NL:             EQU 0x0009  ; New line
PRNT:           EQU 0x0012  ; 1 CHARACTER PRINT
MSG:            EQU 0x0015  ; 1 LINE PRINT (END "0DH")
MSGX:           EQU 0x18    ; RST 18H
GETKY:          EQU 0x001B  ; GET KEY
BRKEY:          EQU 0x001E	; GET BREAK
WRINF:          EQU 0x0021  ; WRITE INFORMATION
WRDAT:          EQU 0x0024  ; WRITE DATA
RDINF:          EQU 0x0027  ; READ INFORMATION
RDDAT:          EQU 0x002A  ; READ DATA
VERFY:          EQU 0x002D  ; VERIFYING CMT
BELL:           EQU 0x003E	; BELL ON
L2HEX:          EQU 0x041F  ; 2 ASCII TO (ACC)
QQKEY:          EQU 0x09B3  ; KEY BOARD SEARCH
QDACN:          EQU 0x0BCE  ; DISPLAY CODE TO ASCII CONVERSION
; ----------------------------------------------------------------------
ECRAN_TEXTE:    EQU 0xD000  ; Adresse de l'ecran TEXTE
DSPXY:          EQU 0x1171  ; Adresse des coordonnees XY du curseur
ATRB:           EQU 0x10F0
NAME:           EQU 0x10F1
SIZE:           EQU 0x1102
; ----------------------------------------------------------------------
EFFACE_ECRAN:   EQU 0x16
DROITE:         EQU 0x13
GAUCHE:         EQU 0x14
BAS:            EQU 0x11
HAUT:           EQU 0x12
HOME:           EQU 0x15
CR:             EQU 0x0D
; ======================================================================

; ======================================================================
; Variables et constantes du jeu
; ----------------------------------------------------------------------
POPULATION_COURANTE:        EQU 0x9000    ; Adresse de stockage
POPULATION_INITIALE:        EQU 0x9500    ; Adresse de stockage
NOMBRE_ELEMENTS:            EQU 0x03E8    ; 1000 cellules x2x2
POPULATION_VIDE:            EQU 0xF0

if LANGAGE = 0
TOUCHE_EDNP:                EQU 0x4E    ; N Nouveau
TOUCHE_JEU:                 EQU 0x4A    ; J Jeu
TOUCHE_CONTINUE_JEU:        EQU 0x52    ; R Reprise
TOUCHE_EPI:                 EQU 0x49    ; I Initale
TOUCHE_EPA:                 EQU 0x41    ; A Actuelle
TOUCHE_SAUVE:               EQU 0x53    ; S Sauvegarde
TOUCHE_CHARGE:              EQU 0x43    ; C Charge
TOUCHE_VERIFIE:             EQU 0x56    ; V Verification
endif

if LANGAGE = 1
TOUCHE_EDNP:                EQU 0x47    ; G Eingabe
TOUCHE_JEU:                 EQU 0x42    ; B LIVE
TOUCHE_CONTINUE_JEU:        EQU 0x57    ; W Weter nach break
TOUCHE_EPI:                 EQU 0x45    ; E Ergänzen
TOUCHE_EPA:                 EQU 0x55    ; U Ergänzen nach break
TOUCHE_SAUVE:               EQU 0x53    ; L Load
TOUCHE_CHARGE:              EQU 0x4C    ; S Save
TOUCHE_VERIFIE:             EQU 0x56    ; V Verify
endif

if LANGAGE = 2
TOUCHE_EDNP:                EQU 0x4E    ; N New
TOUCHE_JEU:                 EQU 0x47    ; G Game
TOUCHE_CONTINUE_JEU:        EQU 0x52    ; R Resume
TOUCHE_EPI:                 EQU 0x49    ; I Initial
TOUCHE_EPA:                 EQU 0x41    ; A Actual
TOUCHE_SAUVE:               EQU 0x53    ; L Load
TOUCHE_CHARGE:              EQU 0x4C    ; S Save
TOUCHE_VERIFIE:             EQU 0x56    ; V Verify
endif

TOUCHE_CR:                  EQU 0x66    ; Entree
TOUCHE_DROITE:              EQU 0x13    ; Direction droite
TOUCHE_GAUCHE:              EQU 0x14    ; Direction gauche
TOUCHE_BAS:                 EQU 0x11    ; Direction bas
TOUCHE_HAUT:                EQU 0x12    ; Direction haut
; ======================================================================

; ======================================================================
; BOOT
; ----------------------------------------------------------------------
DEBUT:
; Rempli la zone POPULATION_COURANTE (1082 octets) de POPULATION_VIDE
	LD HL, POPULATION_COURANTE-(40+1)
	LD BC, NOMBRE_ELEMENTS+2*(40+1)
;
REMPLISSAGE_BOUCLE:
	LD A, POPULATION_VIDE
	LD (HL), A
	INC HL
	DEC BC
	LD A, B
	OR C
	JR NZ, REMPLISSAGE_BOUCLE

; Affiche le menu general
AFFICHE_MENU_GENERAL:
	LD DE, MENU_GENERAL
	CALL MSG

	LD DE, CODES_1
	LD B, 0
	LD A, POPULATION_VIDE+1
	EX AF, AF'
; Affiche colonne 1 de codes
	LD HL, ECRAN_TEXTE+2*40+31
	CALL AFFICHE_CODES
; Affiche colonne 2 de codes
	LD HL, ECRAN_TEXTE+0*40+36
	CALL AFFICHE_CODES
;
AFFICHE_MENU_GENERAL_BOUCLE_TOUCHE1:
	CALL GETKY
	CP 0
	JR NZ, AFFICHE_MENU_GENERAL_BOUCLE_TOUCHE1
;
AFFICHE_MENU_GENERAL_BOUCLE_TOUCHE2:
	CALL GETKY
	CP 0
	JR Z, AFFICHE_MENU_GENERAL_BOUCLE_TOUCHE2
; Touche EDNP
	CP TOUCHE_EDNP
	JP Z, EDITEUR_NOUVELLE_POPULATION
; Touche JEU
	CP TOUCHE_JEU
	JP Z, JEU_DE_LA_VIE
; Touche CONTINUE_JEU
	CP TOUCHE_CONTINUE_JEU
	JP Z, JEU_CONTINUE
; Touche EPI
	CP TOUCHE_EPI
	JP Z, EDITION_POPULATION_INITIALE
; Touche EPA
	CP TOUCHE_EPA
	JP Z, EDITION_POPULATION_ACTUELLE
; Touche SAUVE
	CP TOUCHE_SAUVE
	JP Z, SAUVEGARDE
; Touche CHARGE
	CP TOUCHE_CHARGE
	JP Z, CHARGEMENT
; Touche VERIFIE
	CP TOUCHE_VERIFIE
	JP Z, VERIFICATION
;
	CALL BELL
	JR AFFICHE_MENU_GENERAL_BOUCLE_TOUCHE1
; ----------------------------------------------------------------------

; ======================================================================
; Affiche un ensemble de code entre F0 et FF dont la position relative
; est pointee par DE dans (HL) terminee par 0x0D dans le menu seulement
; ----------------------------------------------------------------------
AFFICHE_CODES:
	LD A, (DE)
	INC DE
	CP 0x0d
	RET Z
	LD C, A
	ADD HL, BC
	EX AF, AF'
	LD (HL), A
	INC A
	EX AF, AF'
	JR AFFICHE_CODES
; ----------------------------------------------------------------------

; ======================================================================
; Transfert le contenu de ECRAN_TEXTE vers POPULATION_COURANTE
; sur 910 octets (?? erreur certainement NOMBRE_ELEMENTS octets)
; (DE)<-(HL) sur BC octets
; ----------------------------------------------------------------------
POPULATION_ECRAN_VERS_POPULATION_COURANTE:
	LD HL, ECRAN_TEXTE
	LD DE, POPULATION_COURANTE
	LD BC, NOMBRE_ELEMENTS
	LDIR
	RET
; ----------------------------------------------------------------------

; ======================================================================
; Transfert le contenu de POPULATION_INITIALE vers ECRAN_TEXTE sur NOMBRE_ELEMENTS octets
; (DE)<-(HL) sur BC octets
; ----------------------------------------------------------------------
POPULATION_INITIALE_VERS_ECRAN:
	LD HL, POPULATION_INITIALE
POPULATION_VERS_ECRAN:
	LD DE, ECRAN_TEXTE
	LD BC, NOMBRE_ELEMENTS
	LDIR
	RET
; ----------------------------------------------------------------------

; ======================================================================
; Transfert le contenu de POPULATION_COURANTE vers ECRAN_TEXTE sur NOMBRE_ELEMENTS caracteres
; (DE)<-(HL) sur BC octets
; ----------------------------------------------------------------------
TRANSFERT_POPULATION_VERS_ECRAN_TEXTE:
	LD HL, POPULATION_COURANTE
	LD DE, ECRAN_TEXTE
	LD BC, NOMBRE_ELEMENTS
	LDIR
	RET
; ----------------------------------------------------------------------

; ======================================================================
; Editeur de la nouvelle population : Menu G
; ----------------------------------------------------------------------
EDITEUR_NOUVELLE_POPULATION:
	CALL INIT_GENERAL
EDITEUR_NOUVELLE_POPULATION_ENTREE_CHAUDE:
	LD HL, ECRAN_TEXTE+11*40+21  ; Position memoire du curseur

EDITEUR_NOUVELLE_POPULATION_BOUCLE_TOUCHE:
	CALL GETKY
	CP 0
	JR NZ, EDITEUR_NOUVELLE_POPULATION_BOUCLE_TOUCHE
;
EDITEUR_NOUVELLE_POPULATION_BOUCLE_LECTURE:
	CALL QQKEY
	CALL QDACN
	CP 0
	JR Z, EDITEUR_NOUVELLE_POPULATION_BOUCLE_LECTURE
; Touche (CR)
	CP TOUCHE_CR
	JR Z, EDITEUR_NOUVELLE_POPULATION_TOUCHE_CR
; Touche DROITE
	CP TOUCHE_DROITE
	JR Z, EDITEUR_NOUVELLE_POPULATION_TOUCHE_DROITE
; Touche GAUCHE
	CP TOUCHE_GAUCHE
	JR Z, EDITEUR_NOUVELLE_POPULATION_TOUCHE_GAUCHE
; Touche BAS
	CP TOUCHE_BAS
	JR Z, EDITEUR_NOUVELLE_POPULATION_TOUCHE_BAS
; Touche HAUT
	CP TOUCHE_HAUT
	JR Z, EDITEUR_NOUVELLE_POPULATION_TOUCHE_HAUT
; Stocke la valeur de A en VALEUR_TOUCHE_2 (VALEUR_TOUCHE_1=0x30 "0")
	LD (VALEUR_TOUCHE_2), A
	LD DE, VALEUR_TOUCHE_1
; Converti la valeur sur 2 octets en ASCII vers une valeur hexa en A
; "00" -> "0F" => 0x00 a 0x0F
	CALL L2HEX
	JR C, EDITEUR_NOUVELLE_POPULATION_TOUCHE_INVALIDE
; Affiche le nouveau caractere en ajouter la valeur a POPULATION_VIDE
	ADD A, POPULATION_VIDE
; Affiche le nouveau caractere
	LD (HL), A
; Reboucle
	JP EDITEUR_NOUVELLE_POPULATION_BOUCLE_TOUCHE
;
; Touche invalide
;
EDITEUR_NOUVELLE_POPULATION_TOUCHE_INVALIDE:
	CALL BELL
	JR EDITEUR_NOUVELLE_POPULATION_BOUCLE_TOUCHE
;
; Touche (CR) : Fin d'edition
;
EDITEUR_NOUVELLE_POPULATION_TOUCHE_CR:
	CALL POPULATION_ECRAN_VERS_POPULATION_COURANTE
; Transfert l'ecran TEXTE vers la memoire de la population initiale
; (DE)<-(HL) sur BC octets
	LD HL, ECRAN_TEXTE
	LD DE, POPULATION_INITIALE
	LD BC, NOMBRE_ELEMENTS
	LDIR
; Revient au menu general
	JP AFFICHE_MENU_GENERAL
;
; Touche DROITE
;
EDITEUR_NOUVELLE_POPULATION_TOUCHE_DROITE:
	INC HL
;
; Affiche le curseur et revient dans la boucle
;
EDITEUR_NOUVELLE_POPULATION_TOUCHE_FIN:
	CALL PRNT
	JR EDITEUR_NOUVELLE_POPULATION_BOUCLE_TOUCHE
;
; Touche GAUCHE
;
EDITEUR_NOUVELLE_POPULATION_TOUCHE_GAUCHE:
	DEC HL
	JR EDITEUR_NOUVELLE_POPULATION_TOUCHE_FIN
;
; Touche BAS
;
EDITEUR_NOUVELLE_POPULATION_TOUCHE_BAS:
	LD DE, 40
	ADD HL, DE
	JR EDITEUR_NOUVELLE_POPULATION_TOUCHE_FIN
;
; Touche HAUT
;
EDITEUR_NOUVELLE_POPULATION_TOUCHE_HAUT:
	LD DE, 40
	OR A
	SBC HL, DE
	JR EDITEUR_NOUVELLE_POPULATION_TOUCHE_FIN
; ----------------------------------------------------------------------

; ======================================================================
; Jeu lui-meme : Touche B
; ----------------------------------------------------------------------
JEU_DE_LA_VIE:
	CALL INIT_POPULATION
JEU_DE_LA_VIE_ENTREE_CHAUDE:
; Initialisations pour debut analyse population courante
	LD DE, ECRAN_TEXTE
	LD HL, POPULATION_COURANTE
	LD BC, 40
;
; Bit 0 -> * * <- Bit 1
; Bit 2 -> * * <- Bit 3
;
; |--|--|--|
; |**|**|**|
; |*6|78|**|
; |--|--|--|
; |*5|?1|**|
; |*4|32|**|
; |--|--|--|
; |**|**|**|
; |**|**|**|
; |--|--|--|
;
JEU_BOUCLE:
; Met le nombre de cellules a 0
	XOR A
;
; Comptage
;
; Test a droite en haut [1]
	BIT 1, (HL)
	JR Z, JEU_00
; Si presence ajoute 1
	INC A
JEU_00:
; Test a droite en bas [2]
	BIT 3, (HL)
	JR Z, JEU_01
; Si presence ajoute 1
	INC A
JEU_01:
; Test en gauche en bas [3]
	BIT 2, (HL)
	JR Z, JEU_02
; Si presence ajoute 1
	INC A
JEU_02:
; Passe a la cellule de gauche
	DEC HL
; Test a droite en bas [4]
	BIT 3, (HL)
	JR Z, JEU_03
; Si presence ajoute 1
	INC A
JEU_03:
; Test a droite en haut [5]
	BIT 1, (HL)
	JR Z, JEU_04
; Si presence ajoute 1
	INC A
JEU_04:
; Passe a la cellule au dessus a gauche
	OR A
	SBC HL, BC
; Test a droite en bas [6]
	BIT 3, (HL)
	JR Z, JEU_05
; Si presence ajoute 1
	INC A
JEU_05:
; Passe a la cellule au dessus
	INC HL
; Test en gauche en bas [7]
	BIT 2, (HL)
	JR Z, JEU_06
; Si presence ajoute 1
	INC A
JEU_06:
; Test a droite en bas [8]
	BIT 3, (HL)
	JR Z, JEU_07
; Si presence ajoute 1
	INC A
;
; Determine etat de la cellule
;
JEU_07:
; Passe a la cellule elle-meme
	ADD HL, BC
; Test le bit concerne
	BIT 0, (HL)
; SI cellule existe alors va en JEU_08
	JR NZ, JEU_08
; Bit a 0 donc regle des 3 cellules environnantes
	CP 3
; Si le nombre de cellules environnantes est <> 3 alors efface
	JR NZ, JEU_09
; Sinon si egal a 3 alors ajoute
	JR JEU_10
JEU_08:
; Bit a 1 donc regle des 2 cellules environnantes
	CP 2
; Si le nombre de cellules < 2 alors efface
	JR C, JEU_09
; ou regle des 4 cellules environnantes
	CP 4
; Si le nombre de cellules < 4 alors ajoute
	JR C, JEU_10
JEU_09:
; Efface la cellule testee sur ecran directement
	PUSH HL
	 LD H, D
	 LD L, E
	 RES 0, (HL)
	POP HL
	JR JEU_11
JEU_10:
; Ajoute la cellule testee sur ecran directement
	PUSH HL
	 LD H, D
	 LD L, E
	 SET 0, (HL)
	POP HL
;
; Suite
;
;
; |--|--|--|
; |**|**|**|
; |**|78|6*|
; |--|--|--|
; |**|1?|4*|
; |**|32|5*|
; |--|--|--|
; |**|**|**|
; |**|**|**|
; |--|--|--|
;
JEU_11:
; Met le nombre de cellules a 0
	XOR A
; Test a gauche [1]
	BIT 0, (HL)
	JR Z, JEU_12
; Si presence ajoute 1
	INC A
JEU_12:
; Test en dessous [2]
	BIT 3, (HL)
	JR Z, JEU_13
; Si presence ajoute 1
	INC A
JEU_13:
; Test a gauche en bas [3]
	BIT 2, (HL)
	JR Z, JEU_14
; Si presence ajoute 1
	INC A
JEU_14:
; Passe a la cellule de droite
	INC HL
; Test a gauche [4]
	BIT 0, (HL)
	JR Z, JEU_15
; Si presence ajoute 1
	INC A
JEU_15:
; Test a gauche en bas [5]
	BIT 2, (HL)
	JR Z, JEU_16
; Si presence ajoute 1
	INC A
JEU_16:
; Passe a la cellule au dessus
	OR A
	SBC HL, BC
; Test a gauche en bas [6]
	BIT 2, (HL)
	JR Z, JEU_17
; Si presence ajoute 1
	INC A
JEU_17:
; Passe a la cellule a gauche en haut
	DEC HL
; Test a gauche en bas [7]
	BIT 2, (HL)
	JR Z, JEU_18
; Si presence ajoute 1
	INC A
JEU_18:
; Test a droite en bas [8]
	BIT 3, (HL)
	JR Z, JEU_19
; Si presence ajoute 1
	INC A
JEU_19:
; Passe a la cellule elle-meme
	ADD HL, BC
; Test le bit concerne
	BIT 1, (HL)
; SI cellule existe alors va en JEU_20
	JR NZ, JEU_20
; Bit a 0 donc regle des 3 cellules environnantes
	CP 3
; Si le nombre de cellules environnantes est <> 3 alors efface
	JR NZ, JEU_21
; Sinon si egal a 3 alors ajoute
	JR JEU_22
JEU_20:
; Bit a 1 donc regle des 2 cellules environnantes
	CP 2
; Si le nombre de cellules < 2 alors efface
	JR C, JEU_21
; ou regle des 4 cellules environnantes
	CP 4
; Si le nombre de cellules < 4 alors ajoute
	JR C, JEU_22
JEU_21:
; Efface la cellule testee sur ecran directement
	PUSH HL
	 LD H, D
	 LD L, E
	 RES 1, (HL)
	POP HL
	JR JEU_23
JEU_22:
; Ajoute la cellule testee sur ecran directement
	PUSH HL
	 LD H, D
	 LD L, E
	 SET 1, (HL)
	POP HL
;
; Suite
;
;
; |--|--|--|
; |**|**|**|
; |**|**|**|
; |--|--|--|
; |*5|13|**|
; |*4|?2|**|
; |--|--|--|
; |*6|78|**|
; |**|**|**|
; |--|--|--|
;
JEU_23:
; Met le nombre de cellules a 0
	XOR A
; Test a gauche [1]
	BIT 0, (HL)
	JR Z, JEU_24
; Si presence ajoute 1
	INC A
JEU_24:
; Test a droite en bas [2]
	BIT 3, (HL)
	JR Z, JEU_25
; Si presence ajoute 1
	INC A
JEU_25:
; Test a droite en haut [3]
	BIT 1, (HL)
	JR Z, JEU_26
; Si presence ajoute 1
	INC A
JEU_26:
; Passe a la cellule de gauche (-1)
	DEC HL
; Test a droite en bas [4]
	BIT 3, (HL)
	JR Z, JEU_27
; Si presence ajoute 1
	INC A
JEU_27:
; Test a droite en haut [5]
	BIT 1, (HL)
	JR Z, JEU_28
; Si presence ajoute 1
	INC A
JEU_28:
; Passe a la cellule a gauche en bas (+40)
	ADD HL, BC
; Test a droite en haut [6]
	BIT 1, (HL)
	JR Z, JEU_29
; Si presence ajoute 1
	INC A
JEU_29:
; Passe a la cellule d'en dessous (+1)
	INC HL
; Test a gauche [7]
	BIT 0, (HL)
	JR Z, JEU_30
; Si presence ajoute 1
	INC A
JEU_30:
; Test a droite en haut [8]
	BIT 1, (HL)
	JR Z, JEU_31
; Si presence ajoute 1
	INC A
JEU_31:
; Passe a la cellule elle-meme (-40)
	OR A
	SBC HL, BC
; Test le bit concerne
	BIT 2, (HL)
; SI cellule existe alors va en JEU_32
	JR NZ, JEU_32
; Bit a 0 donc regle des 3 cellules environnantes
	CP 3
; Si le nombre de cellules environnantes est <> 3 alors efface
	JR NZ, JEU_33
; Sinon si egal a 3 alors ajoute
	JR JEU_34
JEU_32:
; Bit a 1 donc regle des 2 cellules environnantes
	CP 2
; Si le nombre de cellules < 2 alors efface
	JR C, JEU_33
; ou regle des 4 cellules environnantes
	CP 4
; Si le nombre de cellules < 4 alors ajoute
	JR C, JEU_34
JEU_33:
; Efface la cellule testee sur ecran directement
	PUSH HL
	 LD H, D
	 LD L, E
	 RES 2, (HL)
	POP HL
	JR JEU_35
JEU_34:
; Ajoute la cellule testee sur ecran directement
	PUSH HL
	 LD H, D
	 LD L, E
	 SET 2, (HL)
	POP HL
;
; Suite
;
;
; |--|--|--|
; |**|**|**|
; |**|**|**|
; |--|--|--|
; |**|13|4*|
; |**|2?|5*|
; |--|--|--|
; |**|78|6*|
; |**|**|**|
; |--|--|--|
;
JEU_35:
; Met le nombre de cellules a 0
	XOR A
; Test a gauche [1]
	BIT 0, (HL)
	JR Z, JEU_36
; Si presence ajoute 1
	INC A
JEU_36:
; Test a gauche en bas [2]
	BIT 2, (HL)
	JR Z, JEU_37
; Si presence ajoute 1
	INC A
JEU_37:
; Test a droite en haut [3]
	BIT 1, (HL)
	JR Z, JEU_38
; Si presence ajoute 1
	INC A
JEU_38:
; Passe a la cellule de droite (+1)
	INC HL
; Test a gauche [4]
	BIT 0, (HL)
	JR Z, JEU_39
; Si presence ajoute 1
	INC A
JEU_39:
; Test a gauche en bas [5]
	BIT 2, (HL)
	JR Z, JEU_40
; Si presence ajoute 1
	INC A
JEU_40:
; Passe a la cellule a gauche en bas (+40)
	ADD HL, BC
; Test a gauche [6]
	BIT 0, (HL)
	JR Z, JEU_41
; Si presence ajoute 1
	INC A
JEU_41:
; Passe a la cellule en dessous (-1)
	DEC HL
; Test a gauche [7]
	BIT 0, (HL)
	JR Z, JEU_42
; Si presence ajoute 1
	INC A
JEU_42:
; Test a droite en haut [8]
	BIT 1, (HL)
	JR Z, JEU_43
; Si presence ajoute 1
	INC A
JEU_43:
; Passe a la cellule lui-meme (-40)
	OR A
	SBC HL, BC
; Test le bit concerne
	BIT 3, (HL)
; SI cellule existe alors va en JEU_44
	JR NZ, JEU_44
; Bit a 0 donc regle des 3 cellules environnantes
	CP 3
; Si le nombre de cellules environnantes est <> 3 alors efface
	JR NZ, JEU_45
; Sinon si egal a 3 alors ajoute
	JR JEU_46
JEU_44:
; Bit a 1 donc regle des 2 cellules environnantes
	CP 2
; Si le nombre de cellules < 2 alors efface
	JR C, JEU_45
; ou regle des 4 cellules environnantes
	CP 4
; Si le nombre de cellules < 4 alors ajoute
	JR C, JEU_46
JEU_45:
; Efface la cellule testee sur ecran directement
	PUSH HL
	 LD H, D
	 LD L, E
	 RES 3, (HL)
	POP HL
	JR JEU_47
JEU_46:
; Ajoute la cellule testee sur ecran directement
	PUSH HL
	 LD H, D
	 LD L, E
	 SET 3, (HL)
	POP HL
JEU_47:
; SI H <> 0x93 ALORS VA EN JEU_48
	LD A, H
	CP 0x93
	JR NZ, JEU_48
; SI L = 0xE8 ALORS VA EN JEU_49
	LD A, L
	CP 0xe8
	JR Z, JEU_49
JEU_48:
; Passe a la case suivante
; HL++
; DE++
	INC HL
	INC DE
; Et on boucle pour nouvelle analyse
	JP JEU_BOUCLE
JEU_49:
; Recopie la nouvelle population vers la population courante pour nouvelle analyse
	CALL POPULATION_ECRAN_VERS_POPULATION_COURANTE
; Detecte la touche SHIFT+BREAK
	CALL BRKEY
; SI SHIFT+BREAK QLORS VA EN AFFICHE_MENU_GENERAL
	JP Z, AFFICHE_MENU_GENERAL
; SINON VA EN JEU_DE_LA_VIE_ENTREE_CHAUDE
	JP JEU_DE_LA_VIE_ENTREE_CHAUDE
; ----------------------------------------------------------------------

; ======================================================================
; Initialisation memoire general
; ----------------------------------------------------------------------
INIT_GENERAL:
	CALL INIT_CURSEUR_ET_ADRESSE
; Remplissage par le caractere POPULATION_VIDE sur NOMBRE_ELEMENTS caracteres en (HL)
	LD BC, NOMBRE_ELEMENTS
;
INIT_GENERAL_BOUCLE:
	LD A, POPULATION_VIDE
	LD (HL), A
	INC HL
	DEC BC
	LD A, B
	OR C
	JR NZ, INIT_GENERAL_BOUCLE

	JP TRANSFERT_POPULATION_VERS_ECRAN_TEXTE
; ----------------------------------------------------------------------

; ======================================================================
; Jeu qui continue apres un BREAK : Touche W
; ----------------------------------------------------------------------
JEU_CONTINUE:
	LD HL, POPULATION_COURANTE
	CALL POPULATION_VERS_ECRAN
	JP JEU_DE_LA_VIE_ENTREE_CHAUDE
; ----------------------------------------------------------------------

; ======================================================================
; Edition de la population initiale : Touche E
; ----------------------------------------------------------------------
EDITION_POPULATION_INITIALE:
	CALL INIT_CURSEUR_MILIEU
	CALL POPULATION_INITIALE_VERS_ECRAN
	JP EDITEUR_NOUVELLE_POPULATION_ENTREE_CHAUDE
; ----------------------------------------------------------------------

; ======================================================================
; Edition de la population actuelle : Touche U
; ----------------------------------------------------------------------
EDITION_POPULATION_ACTUELLE:
	CALL INIT_CURSEUR_MILIEU
	CALL TRANSFERT_POPULATION_VERS_ECRAN_TEXTE
	JP EDITEUR_NOUVELLE_POPULATION_ENTREE_CHAUDE
; ----------------------------------------------------------------------

; ======================================================================
; Initialise le curseur en (21;11) et retourne A=0x32
; ----------------------------------------------------------------------
INIT_CURSEUR_MILIEU:
	LD A, 21
	LD (DSPXY), A
	LD A, 11
	LD (DSPXY+1), A
	LD A, 0x32
	RET
; ----------------------------------------------------------------------

; ======================================================================
; Initialise la population courante et prenant la population initiale
; ----------------------------------------------------------------------
INIT_POPULATION:
; POPULATION_INITIALE -> ECRAN_TEXTE sur NOMBRE_ELEMENTS octets
	CALL POPULATION_INITIALE_VERS_ECRAN
; ECRAN_TEXTE -> POPULATION_COURANTE sur NOMBRE_ELEMENTS octets
	CALL POPULATION_ECRAN_VERS_POPULATION_COURANTE
	RET
; ----------------------------------------------------------------------

; ======================================================================
; Initialisation du curseur et adresse memoire
; ----------------------------------------------------------------------
INIT_CURSEUR_ET_ADRESSE:
	CALL INIT_CURSEUR_MILIEU
	LD HL, POPULATION_COURANTE
	RET
; ----------------------------------------------------------------------

; ======================================================================
; Sauvegarde : Touche S
; ----------------------------------------------------------------------
SAUVEGARDE:
; Efface l'ecran
	LD A, EFFACE_ECRAN
	CALL PRNT
; Affiche "FILENAME? "
	LD DE, MESSAGE_FILENAME
	RST MSGX
; Nouvelle ligne
	CALL NL
; Lecture au clavier de la valeur stockee en NAME
	LD DE, NAME
	CALL GETL
; Transfert les caracteristiques des donnees stockee en SAUVEGARDE_CARACTERISTIQUES
; (DE)<-(HL) sur BC octets
	LD HL, SAUVEGARDE_CARACTERISTIQUES
	LD DE, SIZE
	LD BC, 6
	LDIR
; Positionne le type de fichier a 1 (BIN)
	LD HL, ATRB
	LD (HL), 1
; Ecriture entetes
	CALL WRINF
; SI Erreur ALORS VA EN AFFICHE_ERREUR
	JR C, AFFICHE_ERREUR
; Ecriture donnees
	CALL WRDAT
; ----------------------------------------------------------------------

; ======================================================================
; Test des donnees sauvegardees/verifiees
; ----------------------------------------------------------------------
TEST_DONNEES:
; SI Erreur ALORS VA EN AFFICHE_ERREUR
	JR C, AFFICHE_ERREUR
; Affiche une nouvelle ligne
	CALL NL
; Affiche "OK!"
	LD DE, MESSAGE_OK
	RST MSGX
; Attend l'appui d'une touche
ATTEND_APPUIE_TOUCHE:
	CALL GETKY
	CP 0
	JR Z, ATTEND_APPUIE_TOUCHE
DONNEES_FIN:
	JP AFFICHE_MENU_GENERAL
; ----------------------------------------------------------------------

; ======================================================================
; Affiche ERREUR si probleme lors de la sauvegarde/lecture/verification
; ----------------------------------------------------------------------
AFFICHE_ERREUR:
	CP 2
	JR Z, DONNEES_FIN
; Affiche le message "CHECK SUM ER "
	LD DE, MESSAGE_CHECK_SUM_ERROR
	RST MSGX
	JR ATTEND_APPUIE_TOUCHE
; ----------------------------------------------------------------------

; ======================================================================
; Verification : Touche V
; ----------------------------------------------------------------------
VERIFICATION:
; Efface l'ecran
	LD A, EFFACE_ECRAN
	CALL PRNT
; Verification des donnees
	CALL VERFY
; Va en test
	JR TEST_DONNEES
; ----------------------------------------------------------------------

; ======================================================================
; Chargement : Touche L
; ----------------------------------------------------------------------
CHARGEMENT:
; Efface l'ecran
	LD A, EFFACE_ECRAN
	CALL PRNT
; Lecture de l'entete
	CALL RDINF
; Si erreur alors Arret et affiche ER
	JR C, AFFICHE_ERREUR
; Nouvelle ligne
	CALL NL
; Affiche "LOADING "
	LD DE, MESSAGE_LOADING
	RST MSGX
; Affiche le nom du fichier en cours de chargement
	LD DE, NAME
	RST MSGX
; Lecture des donnees
	CALL RDDAT
; Si erreur alors Arret et affiche ER
	JR C, AFFICHE_ERREUR
; Affiche la population initiale
; Initialise la population sur ecran
	CALL POPULATION_INITIALE_VERS_ECRAN
; Transfert vers la population courante
	CALL POPULATION_ECRAN_VERS_POPULATION_COURANTE
	JR ATTEND_APPUIE_TOUCHE
; ----------------------------------------------------------------------

VALEUR_TOUCHE_1:
    DB 0x30
VALEUR_TOUCHE_2:
    DB 0x30

MENU_GENERAL:
    DB EFFACE_ECRAN
if LANGAGE = 0
    DB "      JEU DE LA VIE"
endif
if LANGAGE = 1
    DB " POPULATIONS-ENTWICKLUNG"
endif
if LANGAGE = 2
    DB "      GAME OF LIFE"
endif

    DB HOME, BAS, BAS, BAS, BAS

if LANGAGE = 0
    DB "N..NOUVELLE POPULATION (CR)"
endif
if LANGAGE = 1
    DB "G..", 0x45, 0xa6, 0xb0, 0x97, 0xa1, 0x9a, 0x92, 0x20, 0x28, 0x43, 0x52, 0x29
endif
if LANGAGE = 2
    DB "N..NEW POPULATION (CR)"
endif

    DB HOME, BAS, BAS, BAS, BAS, BAS, BAS

if LANGAGE = 0
    DB "J..LE JEU (BREAK)"
endif
if LANGAGE = 1
    DB "B..", 0x4c, 0x49, 0x56, 0x45, 0x20, 0x28, 0x42, 0x9d, 0x92, 0xa1, 0xa9, 0x29
endif
if LANGAGE = 2
    DB "G..THE GAME (BREAK)"
endif

    DB HOME, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS

if LANGAGE = 0
    DB "R..REPRISE APRES UN BREAK"
endif
if LANGAGE = 1
    DB "W..", 0x57, 0x92, 0xa6, 0x96, 0x92, 0x9d, 0x20, 0xb0, 0xa1, 0x9f, 0x98, 0x20, 0x42, 0x9d, 0x92, 0xa1, 0xa9
endif
if LANGAGE = 2
    DB "R..RESUME AFTER A BREAK"
endif
    
    DB HOME, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS

if LANGAGE = 0
    DB "I..ED. POPULATION INITIALE"
endif
if LANGAGE = 1
    DB "E..", 0x45, 0x9d, 0x97, 0xbb, 0xb0, 0xa2, 0x92, 0xb0
endif
if LANGAGE = 2
    DB "I..ED. INITIAL POPULATION"
endif
    
    DB HOME, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS

if LANGAGE = 0
    DB "A..ED. POPULATION ACTUELLE"
endif
if LANGAGE = 1
    DB "U..", 0x45, 0x9d, 0x97, 0xbb, 0xb0, 0xa2, 0x92, 0xb0, 0x20, 0xb0, 0xa1, 0x9f, 0x98, 0x20, 0x42, 0x9d, 0x92, 0xa1, 0xa9
endif
if LANGAGE = 2
    DB "A..CURRENT POPULATION ED."
endif

    DB HOME, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS

if LANGAGE = 0
    DB "C..CHARGER"
endif
if LANGAGE = 1
    DB "L..", 0x4c, 0xb7, 0xa1, 0x9c
endif
if LANGAGE = 2
    DB "L..", 0x4c, 0xb7, 0xa1, 0x9c
endif

    DB HOME, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS

if LANGAGE = 0
    DB "S..SAUVEGARDER"
endif
if LANGAGE = 1
    DB "S..", 0x53, 0xa1, 0xab, 0x92
endif
if LANGAGE = 2
    DB "S..", 0x53, 0xa1, 0xab, 0x92
endif

    DB HOME, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS

if LANGAGE = 0
    DB "V..VERIFIER DONNEES"
endif
if LANGAGE = 1
    DB "V..", 0x56, 0x92, 0x9d, 0xa6, 0xaa, 0xbd
endif
if LANGAGE = 2
    DB "V..", 0x56, 0x92, 0x9d, 0xa6, 0xaa, 0xbd
endif

    DB HOME, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS, BAS
    DB GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE
    DB HAUT, HAUT, HAUT
    DB 0xCD, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xDD
    DB HAUT, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE, GAUCHE
    DB 0xFD, "7", GAUCHE, GAUCHE, HAUT
    DB 0xFD, GAUCHE, HAUT
    DB 0xFD, "6", GAUCHE, GAUCHE, HAUT
    DB 0xFD, GAUCHE, HAUT
    DB 0xFD, "5", GAUCHE, GAUCHE, HAUT
    DB 0xFD, GAUCHE, HAUT
    DB 0xFD, "4", GAUCHE, GAUCHE, HAUT
    DB 0xFD, GAUCHE, HAUT
    Db 0xFD, "3", GAUCHE, GAUCHE, HAUT
    DB 0xFD, GAUCHE, HAUT
    DB 0xFD, "2", GAUCHE, GAUCHE, HAUT
    DB 0xFD, GAUCHE, HAUT
    DB 0xFD, "1", GAUCHE, GAUCHE, HAUT
    DB 0xFD, GAUCHE, HAUT
    DB 0xFD, "0", GAUCHE, GAUCHE, HAUT
    DB 0xD0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xCE
    DB GAUCHE, GAUCHE, GAUCHE, GAUCHE, BAS
    DB "8  ", 0xFD, GAUCHE, BAS
    DB 0xFD, GAUCHE, GAUCHE, GAUCHE, GAUCHE, BAS
    DB "9  ", 0xFD, GAUCHE, BAS
    DB 0xFD, GAUCHE, GAUCHE, GAUCHE, GAUCHE, BAS
    DB "A  ", 0xFD, GAUCHE, BAS
    DB 0xFD, GAUCHE, GAUCHE, GAUCHE, GAUCHE, BAS
    DB "B  ", 0xFD, GAUCHE, BAS
    DB 0xFD, GAUCHE, GAUCHE, GAUCHE, GAUCHE, BAS
    DB "C  ", 0xFD, GAUCHE, BAS
    DB 0xFD, GAUCHE, GAUCHE, GAUCHE, GAUCHE, BAS
    DB "D  ", 0xFD, GAUCHE, BAS
    DB 0xFD, GAUCHE, GAUCHE, GAUCHE, GAUCHE, BAS
    DB "E  ", 0xFD, GAUCHE, BAS
    DB 0xFD, GAUCHE, GAUCHE, GAUCHE, GAUCHE, BAS
    DB "F  ", 0xFD
    DB CR

; Positions de l'affichage des caracteres CODES du menu Colonne 1
CODES_1:
    DB 80, 80, 80, 80, 80, 80, 80, CR

; Positions de l'affichage des caracteres CODES du menu Colonne 2
CODES_2:
    DB 80, 80, 80, 80, 80, 80, 80, 80, CR

; Donnees pour sauvegarde
SAUVEGARDE_CARACTERISTIQUES:
; Taille = 0x03E8 (NOMBRE_ELEMENTS octets)
    DB 0xE8, 0x03
; Adresse de depart (0x9500)
    DB 0x00, 0x95
; Adresse d'execution (0x00AD)
    DB 0xAD, 0x00

if LANGAGE = 0
MESSAGE_CHECK_SUM_ERROR:
    DB "ERREUR SOMME DE VERIFICATION", 0x0d

MESSAGE_OK:
    DB "PARFAIT !", 0x0d

MESSAGE_FILENAME:
    DB "NOM DU FICHIER ? ", 0x0d

MESSAGE_LOADING:
    DB "CHARGEMENT DE ", 0x0d
endif

if LANGAGE = 1
MESSAGE_CHECK_SUM_ERROR:
    DB "CHECK SUM ER.", 0x0d

MESSAGE_OK:
    DB "OK!", 0x0d

MESSAGE_FILENAME:
    DB "FILENAME? ", 0x0d

MESSAGE_LOADING:
    DB "LOADING ", 0x0d
endif

if LANGAGE = 2
MESSAGE_CHECK_SUM_ERROR:
    DB "CHECK SUM ER.", 0x0d

MESSAGE_OK:
    DB "OK!", 0x0d

MESSAGE_FILENAME:
    DB "FILENAME? ", 0x0d

MESSAGE_LOADING:
    DB "LOADING ", 0x0d
endif
